/*
 * This file is part of the AdvanceMAME project
 *
 * Copyright (C) 1999-2000 Andrea Mazzoleni
 *
 * The contents of this file are free for non-commercial use.
 * Any commercial use is forbidden.
 */

#include "screen.h"
#include "vbe.h"
#include "vbeline.h"
#include "vgaline.h"
#include "vgatweak.h"

#include <stdio.h>

void video_log_va(const char *text, va_list arg)
{
	(void)text;
	(void)arg;
}

int my_video_mode_grab(video_mode* mode) {
	if (vbe_mode_grab(&mode->driver.vbe)==0 && vbe_mode_import(mode)==0)
		return 0;
	if (vgaline_mode_grab(&mode->driver.vgaline)==0 && vgaline_mode_import(mode)==0)
		return 0;
	if (vgatweak_mode_grab(&mode->driver.vgatweak)==0 && vgatweak_mode_import(mode)==0)
		return 0;
	return -1;
}

int main() {
	video_mode vm;
	char buffer[2048];

	video_init();

	if (my_video_mode_grab(&vm) == 0) {
		strcpy(vm.name,"current");
		video_mode_print(buffer,&vm);
		printf("%s\n",buffer);
	} else {
		fprintf(stderr,"error detecting the video mode\n");
	}

	video_done();

	return 0;
}
