#ifndef __OSINLINE__
#define __OSINLINE__

/* What goes herein depends heavily on the OS. */

#if 0

extern void osd_mark_dirty_point(int posx, int posy);

/* This version is correct */
INLINE void osd_mark_vector_dirty(unsigned x,unsigned y) {
	osd_mark_dirty_point(x,y);
}

#else

#include "dirty.h"

/* This version is fast but don't support blit rotation for vector game */
INLINE void osd_mark_vector_dirty(unsigned x,unsigned y) {
	dirty_set(x / DIRTY_DELTA_X, y / DIRTY_DELTA_Y);
}

#endif

#define vec_mult _vec_mult
INLINE int _vec_mult(int x, int y)
{
	int result;
	asm (
			"movl  %1    , %0    ; "
			"imull %2            ; "    /* do the multiply */
			"movl  %%edx , %%eax ; "
			:  "=&a" (result)           /* the result has to go in eax */
			:  "mr" (x),                /* x and y can be regs or mem */
			   "mr" (y)
			:  "%edx", "%cc"            /* clobbers edx and flags */
		);
	return result;
}

INLINE unsigned int osd_cycles(void)
{
	int result;

	__asm__ __volatile__ (
		"rdtsc                 \n"	/* load clock cycle counter in eax and edx */
		:  "=&a" (result)			/* the result has to go in eax */
		:							/* no inputs */
		:  "%edx"					/* clobbers edx */
	);

	return result;
}

#endif /* __OSINLINE__ */
