/*
 * This file is part of the AdvanceMAME project
 *
 * Copyright (C) 1999-2000 Andrea Mazzoleni
 *
 * The contents of this file are free for non-commercial use.
 * Any commercial use is forbidden.
 */

#ifndef __FONT_H
#define __FONT_H

#ifdef __cplusplus
extern "C" {
#endif

#include "bitmap.h"

#define BITMAP_FONT_MAX 256

struct bitmapfont {
	struct bitmap* data[BITMAP_FONT_MAX];
};

struct bitmapfont* bitmapfont_default(void);
struct bitmapfont* bitmapfont_load_psf(const char* file);
struct bitmapfont* bitmapfont_load_raw(const char* file);
struct bitmapfont* bitmapfont_inport_raw(unsigned char* data, unsigned data_size);
struct bitmapfont* bitmapfont_load(const char* file);
void bitmapfont_free(struct bitmapfont* font);
unsigned bitmapfont_size_x(struct bitmapfont* font);
unsigned bitmapfont_size_y(struct bitmapfont* font);

int bitmapfont_set(struct bitmapfont* font);
void bitmapfont_orientation(struct bitmapfont* font, unsigned orientation_mask);

#ifdef __cplusplus
};
#endif

#endif
